#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <mem.h>

unsigned int XMSControl[2];

typedef struct {
	unsigned long Length;
	unsigned int SourceHandle;
	unsigned long SourceOffset;
	unsigned int DestHandle;
	unsigned long DestOffset;
} ExtMemMoveStruct_t;

ExtMemMoveStruct_t XMSMove;

void main(void)
{
	int xms_flag, i;
	unsigned int XMSVersion, XMSTotalFree, XMSHandle;
	char ScratchBuffer[4096];

	_AX= 0x4300;
asm	int 0x2f;

	xms_flag= ( ((_AX & 0x80) == 0x80) ? 1 : 0);

	if (!xms_flag)
	{	printf("XMS not present.\n");
		exit(-1);
	}

	printf("XMS present.\n");

	_AX= 0x4310;
asm	int 0x2f;

	XMSControl[0]= _BX;
	XMSControl[1]= _ES;

	printf("XMSControl= %04X:%04X\n",
		XMSControl[1],XMSControl[0]);

	_AX= 0x0000;
asm	call [XMSControl]
	XMSVersion= _AX;

	printf("XMSVersion= %04X\n",XMSVersion);

	_AX= 0x0800;
asm	call [XMSControl]
	XMSTotalFree= _DX;

	printf("XMSTotalFree= %dK\n",XMSTotalFree);

////////// Allocate 64K of XMS //////////

	_AX= 0x0900;
	_DX= 64;		// request 64K of XMS
asm	call [XMSControl]

	if (_AX != 1)
	{	printf("XMSAllocate failed, ERR= %02X\n",(_BX & 0xff));
		exit(-1);
	}
	XMSHandle= _DX;

	printf("XMSAlloc complete. XMSHandle= %04X\n",XMSHandle);

	_AX= 0x0800;
asm	call [XMSControl]
	XMSTotalFree= _DX;

	printf("XMSTotalFree= %dK\n",XMSTotalFree);

////////// build a local buffer and copy it into XMS //////////

	memset(ScratchBuffer,0x55,sizeof(ScratchBuffer));

	XMSMove.Length= sizeof(ScratchBuffer);
	XMSMove.SourceHandle= 0;
	XMSMove.SourceOffset= (unsigned long)FP_SEG(ScratchBuffer) << 16 | FP_OFF(ScratchBuffer);
	XMSMove.DestHandle= XMSHandle;
	XMSMove.DestOffset= 0;
	_AX= 0x0B00;
	_SI= FP_OFF(&XMSMove);
asm	call [XMSControl]

	if (_AX != 1)
		printf("XMSMoveOut failed. ERR= %02X\n",(_BX & 0xff));
	else
		printf("XMSMoveOut complete.\n");

	memset(ScratchBuffer,0,sizeof(ScratchBuffer));

	XMSMove.Length= sizeof(ScratchBuffer);
	XMSMove.SourceHandle= XMSHandle;
	XMSMove.SourceOffset= 0;
	XMSMove.DestHandle= 0;
	XMSMove.DestOffset= (unsigned long)FP_SEG(ScratchBuffer) << 16 | FP_OFF(ScratchBuffer);
	_AX= 0x0B00;
	_SI= FP_OFF(&XMSMove);
asm	call [XMSControl]

	if (_AX != 1)
		printf("XMSMoveIn failed. ERR= %02X\n",(_BX & 0xff));
	else
		printf("XMSMoveIn complete.\n");

	for (i=0; i<sizeof(ScratchBuffer); i++)
		if (ScratchBuffer[i] != 0x55)
			break;

	if (i != sizeof(ScratchBuffer))
		printf("XMSMoveCompare failed. i= %d\n",i);
	else
		printf("XMSMoveCompare complete.\n");
	
////////// Free the allocated block //////////

	_AX= 0x0A00;
	_DX= XMSHandle;
asm	call [XMSControl]

	if (_AX != 1)
	{	printf("XMSFree failed, ERR= %02X\n",(_BX & 0xff));
		exit(-1);
	}

	printf("XMSFree complete.\n");

}
